<?php
// Retrieve the JSON content and decode it into an associative array
$data = json_decode(file_get_contents('php://input'), true);

// Check if JSON data is decoded properly
if ($data === null) {
    die('JSON decode error: ' . json_last_error_msg());
}

// Database connection - replace with your database details and use PDO or mysqli
$pdo = new PDO('mysql:host=localhost;dbname=cpvarbia_newcpv', 'cpvarbia_newcpv', '7[[dy~I59n9V', [
    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
]);

// Prepare to handle exceptions
try {
    $pdo->beginTransaction();

    // Handling for Images
    if (isset($data['Image'])) {
        foreach ($data['Image'] as $qodid => $info) {
            foreach ($info['File'] as $file) {
                $fileName = basename($file);
                $qoid = isset($info['QOID']) ? $info['QOID'] : null;
                $sql = "INSERT INTO `ins_answers` (`PStageID`, `QID`, `QOID`, `QODID`, `File`, `Answer`, `Deleted`) VALUES (?, ?, ?, ?, ?, ?, '1')";
                $stmt = $pdo->prepare($sql);
                if (!$stmt->execute([$data['PStageID'], $info['QID'], $qoid, $qodid, $fileName, null])) {
                    // Log detailed error information
                    error_log("Failed to insert Image data for QID " . $info['QID'] . " with error: " . implode(" | ", $stmt->errorInfo()));
                    throw new Exception("Failed to insert Image data for QID " . $info['QID']);
                }
            }
        }
    }

    // Other data handling (UserSelect, Radio, Text, Observation, InsChecklist) as previously defined

    // Commit the transaction
    $pdo->commit();
} catch (Exception $e) {
    // An error occurred; rollback the transaction
    $pdo->rollback();
    echo "Error: " . $e->getMessage();
}
?>
